/* Generated automatically by the program `genrecog'
from the machine description file `md'.  */

#include "config.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "real.h"
#include "output.h"
#include "flags.h"

extern rtx gen_split_2 ();
extern rtx gen_split_4 ();
extern rtx gen_split_6 ();
extern rtx gen_split_36 ();
extern rtx gen_split_63 ();
extern rtx gen_split_107 ();
extern rtx gen_split_108 ();
extern rtx gen_split_112 ();
extern rtx gen_split_113 ();
extern rtx gen_split_114 ();
extern rtx gen_split_115 ();
extern rtx gen_split_117 ();
extern rtx gen_split_120 ();
extern rtx gen_split_123 ();
extern rtx gen_split_125 ();
extern rtx gen_split_129 ();
extern rtx gen_split_168 ();
extern rtx gen_split_169 ();
extern rtx gen_split_170 ();
extern rtx gen_split_171 ();
extern rtx gen_split_195 ();
extern rtx gen_split_198 ();

/* `recog' contains a decision tree
   that recognizes whether the rtx X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.
   If the rtx is valid, recog returns a nonnegative number
   which is the insn code number for the pattern that matched.
   This is the same as the order in the machine description of
   the entry that matched.  This number can be used as an index into
   entry that matched.  This number can be used as an index into various
   insn_* tables, such as insn_templates, insn_outfun, and insn_n_operands
   (found in insn-output.c).

   The third argument to recog is an optional pointer to an int.
   If present, recog will accept a pattern if it matches except for
   missing CLOBBER expressions at the end.  In that case, the value
   pointed to by the optional pointer will be set to the number of
   CLOBBERs that need to be added (it should be initialized to zero by
   the caller).  If it is set nonzero, the caller should allocate a
   PARALLEL of the appropriate size, copy the initial entries, and call
   add_clobbers (found in insn-emit.c) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl in a SEQUENCE if it can be.*/

rtx recog_operand[MAX_RECOG_OPERANDS];

rtx *recog_operand_loc[MAX_RECOG_OPERANDS];

rtx *recog_dup_loc[MAX_DUP_OPERANDS];

char recog_dup_num[MAX_DUP_OPERANDS];

#define operands recog_operand

int
recog_1 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5;
  int tem;

  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != DImode)
    goto ret0;
  switch (GET_CODE (x1))
    {
    case SIGN_EXTEND:
      goto L17;
    case PLUS:
      goto L57;
    case NEG:
      goto L101;
    case MINUS:
      goto L136;
    case MULT:
      goto L154;
    case AND:
      goto L223;
    case ZERO_EXTEND:
      goto L207;
    case IOR:
      goto L238;
    case NOT:
      goto L249;
    case XOR:
      goto L244;
    case ASHIFT:
      goto L291;
    case ASHIFTRT:
      goto L260;
    case LSHIFTRT:
      goto L267;
    case ZERO_EXTRACT:
      goto L277;
    case FIX:
      goto L434;
    case NE:
      goto L541;
    case GT:
      goto L546;
    case GE:
      goto L551;
    case IF_THEN_ELSE:
      goto L556;
    case SMAX:
      goto L668;
    case SMIN:
      goto L681;
    case EQ:
    case LE:
    case LT:
    case LEU:
    case LTU:
      if (alpha_comparison_operator (x1, DImode))
	{
	  ro[1] = x1;
	  goto L536;
	}
    }
  goto ret0;

  L17:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != SImode)
    goto ret0;
  switch (GET_CODE (x2))
    {
    case PLUS:
      goto L50;
    case NEG:
      goto L97;
    case MINUS:
      goto L129;
    case MULT:
      goto L149;
    case SUBREG:
    case REG:
    case MEM:
      if (nonimmediate_operand (x2, SImode))
	{
	  ro[1] = x2;
	  return 0;
	}
    }
  goto ret0;

  L50:
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case SImode:
      switch (GET_CODE (x3))
	{
	case MULT:
	  goto L51;
	case PLUS:
	  goto L75;
	}
    }
  if (reg_or_0_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L19;
    }
  goto ret0;

  L51:
  x4 = XEXP (x3, 0);
  if (reg_or_0_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L52;
    }
  goto ret0;

  L52:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && const48_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L53;
    }
  goto ret0;

  L53:
  x3 = XEXP (x2, 1);
  if (sext_add_operand (x3, SImode))
    {
      ro[3] = x3;
      return 8;
    }
  goto ret0;

  L75:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == SImode && GET_CODE (x4) == MULT && 1)
    goto L76;
  goto ret0;

  L76:
  x5 = XEXP (x4, 0);
  if (reg_or_0_operand (x5, SImode))
    {
      ro[1] = x5;
      goto L77;
    }
  goto ret0;

  L77:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && const48_operand (x5, SImode))
    {
      ro[2] = x5;
      goto L78;
    }
  goto ret0;

  L78:
  x4 = XEXP (x3, 1);
  if (register_operand (x4, SImode))
    {
      ro[3] = x4;
      goto L79;
    }
  goto ret0;

  L79:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[4] = x3;
      if (reload_in_progress)
	return 11;
      }
  goto ret0;

  L19:
  x3 = XEXP (x2, 1);
  if (sext_add_operand (x3, SImode))
    {
      ro[2] = x3;
      return 3;
    }
  goto ret0;

  L97:
  x3 = XEXP (x2, 0);
  if (reg_or_8bit_operand (x3, SImode))
    {
      ro[1] = x3;
      return 14;
    }
  goto ret0;

  L129:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == MULT && 1)
    goto L130;
  if (reg_or_0_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L112;
    }
  goto ret0;

  L130:
  x4 = XEXP (x3, 0);
  if (reg_or_0_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L131;
    }
  goto ret0;

  L131:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && const48_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L132;
    }
  goto ret0;

  L132:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, SImode))
    {
      ro[3] = x3;
      return 20;
    }
  goto ret0;

  L112:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, SImode))
    {
      ro[2] = x3;
      return 17;
    }
  goto ret0;

  L149:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L150;
    }
  goto ret0;

  L150:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, SImode))
    {
      ro[2] = x3;
      return 23;
    }
  goto ret0;

  L57:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case DImode:
      switch (GET_CODE (x2))
	{
	case MULT:
	  goto L58;
	case PLUS:
	  goto L84;
	}
    }
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L33;
    }
  goto ret0;

  L58:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L59;
    }
  goto ret0;

  L59:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && const48_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L60;
    }
  goto ret0;

  L60:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[3] = x2;
      return 9;
    }
  goto ret0;

  L84:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == MULT && 1)
    goto L85;
  goto ret0;

  L85:
  x4 = XEXP (x3, 0);
  if (reg_or_0_operand (x4, DImode))
    {
      ro[1] = x4;
      goto L86;
    }
  goto ret0;

  L86:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && const48_operand (x4, DImode))
    {
      ro[2] = x4;
      goto L87;
    }
  goto ret0;

  L87:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, DImode))
    {
      ro[3] = x3;
      goto L88;
    }
  goto ret0;

  L88:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[4] = x2;
      if (reload_in_progress)
	return 12;
      }
  goto ret0;

  L33:
  x2 = XEXP (x1, 1);
  if (add_operand (x2, DImode))
    {
      ro[2] = x2;
      return 5;
    }
  goto ret0;

  L101:
  x2 = XEXP (x1, 0);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[1] = x2;
      return 15;
    }
  goto ret0;

  L136:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == MULT && 1)
    goto L137;
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L117;
    }
  goto ret0;

  L137:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L138;
    }
  goto ret0;

  L138:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && const48_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L139;
    }
  goto ret0;

  L139:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[3] = x2;
      return 21;
    }
  goto ret0;

  L117:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[2] = x2;
      return 18;
    }
  goto ret0;

  L154:
  x2 = XEXP (x1, 0);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L155;
    }
  goto ret0;

  L155:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[2] = x2;
      return 24;
    }
  goto ret0;

  L223:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case DImode:
      switch (GET_CODE (x2))
	{
	case NOT:
	  goto L224;
	case ASHIFT:
	  goto L383;
	}
    }
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L190;
    }
  goto ret0;

  L224:
  x3 = XEXP (x2, 0);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L225;
    }
  goto ret0;

  L225:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[2] = x2;
      return 43;
    }
  goto ret0;

  L383:
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == CONST_INT && mode_mask_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L384;
    }
  goto ret0;

  L384:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ASHIFT && 1)
    goto L385;
  goto ret0;

  L385:
  x4 = XEXP (x3, 0);
  if (reg_or_8bit_operand (x4, DImode))
    {
      ro[3] = x4;
      goto L386;
    }
  goto ret0;

  L386:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 3 && 1)
    goto L387;
  goto ret0;

  L387:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      return 70;
    }
  goto ret0;

  L190:
  x2 = XEXP (x1, 1);
  if (and_operand (x2, DImode))
    {
      ro[2] = x2;
      return 35;
    }
  goto ret0;

  L207:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case QImode:
      if (register_operand (x2, QImode))
	{
	  ro[1] = x2;
	  return 39;
	}
      break;
    case HImode:
      if (register_operand (x2, HImode))
	{
	  ro[1] = x2;
	  return 41;
	}
      break;
    case SImode:
      if (register_operand (x2, SImode))
	{
	  ro[1] = x2;
	  return 42;
	}
    }
  goto ret0;

  L238:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == NOT && 1)
    goto L239;
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L230;
    }
  goto ret0;

  L239:
  x3 = XEXP (x2, 0);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L240;
    }
  goto ret0;

  L240:
  x2 = XEXP (x1, 1);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[2] = x2;
      return 46;
    }
  goto ret0;

  L230:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[2] = x2;
      return 44;
    }
  goto ret0;

  L249:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == XOR && 1)
    goto L250;
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[1] = x2;
      return 45;
    }
  goto ret0;

  L250:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L251;
    }
  goto ret0;

  L251:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[2] = x3;
      return 48;
    }
  goto ret0;

  L244:
  x2 = XEXP (x1, 0);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L245;
    }
  goto ret0;

  L245:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[2] = x2;
      return 47;
    }
  goto ret0;

  L291:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case DImode:
      switch (GET_CODE (x2))
	{
	case ZERO_EXTRACT:
	  goto L292;
	case ZERO_EXTEND:
	  goto L341;
	}
    }
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L256;
    }
  goto ret0;

  L292:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L293;
    }
  goto ret0;

  L293:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    goto ret0;
  if (XWINT (x3, 0) == 8 && 1)
    goto L294;
  if (GET_CODE (x3) != CONST_INT)
    goto ret0;
  if (XWINT (x3, 0) == 16 && 1)
    goto L306;
  if (XWINT (x3, 0) == 32 && 1)
    goto L318;
  goto ret0;

  L294:
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ASHIFT && 1)
    goto L295;
  goto ret0;

  L295:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && GET_CODE (x4) == PLUS && 1)
    goto L296;
  goto ret0;

  L296:
  x5 = XEXP (x4, 0);
  if (reg_or_8bit_operand (x5, DImode))
    {
      ro[2] = x5;
      goto L297;
    }
  goto ret0;

  L297:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == -1 && 1)
    goto L298;
  goto ret0;

  L298:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 3 && 1)
    goto L299;
  goto ret0;

  L299:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 56 && 1)
    return 60;
  goto ret0;

  L306:
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ASHIFT && 1)
    goto L307;
  goto ret0;

  L307:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && GET_CODE (x4) == PLUS && 1)
    goto L308;
  goto ret0;

  L308:
  x5 = XEXP (x4, 0);
  if (reg_or_8bit_operand (x5, DImode))
    {
      ro[2] = x5;
      goto L309;
    }
  goto ret0;

  L309:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == -2 && 1)
    goto L310;
  goto ret0;

  L310:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 3 && 1)
    goto L311;
  goto ret0;

  L311:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 48 && 1)
    return 61;
  goto ret0;

  L318:
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ASHIFT && 1)
    goto L319;
  goto ret0;

  L319:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && GET_CODE (x4) == PLUS && 1)
    goto L320;
  goto ret0;

  L320:
  x5 = XEXP (x4, 0);
  if (reg_or_8bit_operand (x5, DImode))
    {
      ro[2] = x5;
      goto L321;
    }
  goto ret0;

  L321:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == -4 && 1)
    goto L322;
  goto ret0;

  L322:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 3 && 1)
    goto L323;
  goto ret0;

  L323:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 32 && 1)
    return 62;
  goto ret0;

  L341:
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case QImode:
      if (register_operand (x3, QImode))
	{
	  ro[1] = x3;
	  goto L360;
	}
      break;
    case HImode:
      if (register_operand (x3, HImode))
	{
	  ro[1] = x3;
	  goto L368;
	}
      break;
    case SImode:
      if (register_operand (x3, SImode))
	{
	  ro[1] = x3;
	  goto L376;
	}
    }
  goto ret0;

  L360:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ASHIFT:
      if (GET_MODE (x2) == DImode && 1)
	goto L361;
      break;
    case CONST_INT:
      if (GET_CODE (x2) == CONST_INT && mul8_operand (x2, DImode))
	{
	  ro[2] = x2;
	  return 64;
	}
    }
  goto ret0;

  L361:
  x3 = XEXP (x2, 0);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L362;
    }
  goto ret0;

  L362:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 3 && 1)
    return 67;
  goto ret0;

  L368:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ASHIFT:
      if (GET_MODE (x2) == DImode && 1)
	goto L369;
      break;
    case CONST_INT:
      if (GET_CODE (x2) == CONST_INT && mul8_operand (x2, DImode))
	{
	  ro[2] = x2;
	  return 65;
	}
    }
  goto ret0;

  L369:
  x3 = XEXP (x2, 0);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L370;
    }
  goto ret0;

  L370:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 3 && 1)
    return 68;
  goto ret0;

  L376:
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ASHIFT:
      if (GET_MODE (x2) == DImode && 1)
	goto L377;
      break;
    case CONST_INT:
      if (GET_CODE (x2) == CONST_INT && mul8_operand (x2, DImode))
	{
	  ro[2] = x2;
	  return 66;
	}
    }
  goto ret0;

  L377:
  x3 = XEXP (x2, 0);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L378;
    }
  goto ret0;

  L378:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 3 && 1)
    return 69;
  goto ret0;

  L256:
  x2 = XEXP (x1, 1);
  if (reg_or_6bit_operand (x2, DImode))
    {
      ro[2] = x2;
      return 49;
    }
  goto ret0;

  L260:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == ASHIFT && 1)
    goto L261;
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L273;
    }
  goto ret0;

  L261:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L262;
    }
  goto ret0;

  L262:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[2] = x3;
      goto L263;
    }
  goto ret0;

  L263:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 32 && 1)
    if (INTVAL (operands[2]) >= 33 && INTVAL (operands[2]) <= 35)
      return 50;
  goto ret0;

  L273:
  x2 = XEXP (x1, 1);
  if (reg_or_6bit_operand (x2, DImode))
    {
      ro[2] = x2;
      return 52;
    }
  goto ret0;

  L267:
  x2 = XEXP (x1, 0);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L268;
    }
  goto ret0;

  L268:
  x2 = XEXP (x1, 1);
  if (reg_or_6bit_operand (x2, DImode))
    {
      ro[2] = x2;
      return 51;
    }
  goto ret0;

  L277:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && reg_or_0_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L278;
    }
  goto ret0;

  L278:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && mode_width_operand (x2, DImode))
    {
      ro[2] = x2;
      goto L285;
    }
  goto ret0;

  L285:
  x2 = XEXP (x1, 2);
  switch (GET_CODE (x2))
    {
    case ASHIFT:
      if (GET_MODE (x2) == DImode && 1)
	goto L286;
      break;
    case CONST_INT:
      if (GET_CODE (x2) == CONST_INT && mul8_operand (x2, DImode))
	{
	  ro[3] = x2;
	  return 58;
	}
    }
  goto ret0;

  L286:
  x3 = XEXP (x2, 0);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[3] = x3;
      goto L287;
    }
  goto ret0;

  L287:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 3 && 1)
    return 59;
  goto ret0;

  L434:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L435;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 79;
      }
  goto ret0;

  L435:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[1] = x3;
      if (TARGET_FP)
	return 80;
      }
  goto ret0;

  L541:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L542;
    }
  goto ret0;

  L542:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 100;
  goto ret0;

  L546:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L547;
    }
  goto ret0;

  L547:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 101;
  goto ret0;

  L551:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L552;
    }
  goto ret0;

  L552:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 102;
  goto ret0;

  L556:
  x2 = XEXP (x1, 0);
  if (signed_comparison_operator (x2, VOIDmode))
    {
      ro[2] = x2;
      goto L557;
    }
  L564:
  switch (GET_CODE (x2))
    {
    case EQ:
      goto L565;
    case NE:
      goto L576;
    }
  goto ret0;

  L557:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[3] = x3;
      goto L558;
    }
  goto L564;

  L558:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L602;
  goto L564;

  L602:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == PLUS && 1)
    goto L603;
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L560;
    }
  x2 = XEXP (x1, 0);
  goto L564;

  L603:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[0]) && 1)
    goto L604;
  x2 = XEXP (x1, 0);
  goto L564;

  L604:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L605;
    }
  x2 = XEXP (x1, 0);
  goto L564;

  L605:
  x2 = XEXP (x1, 2);
  if (rtx_equal_p (x2, ro[0]) && pnum_clobbers != 0 && 1)
    {
      *pnum_clobbers = 1;
      return 106;
    }
  x2 = XEXP (x1, 0);
  goto L564;

  L560:
  x2 = XEXP (x1, 2);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[4] = x2;
      return 103;
    }
  x2 = XEXP (x1, 0);
  goto L564;

  L565:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ZERO_EXTRACT && 1)
    goto L566;
  goto ret0;

  L566:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && reg_or_0_operand (x4, DImode))
    {
      ro[2] = x4;
      goto L567;
    }
  goto ret0;

  L567:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 1 && 1)
    goto L568;
  goto ret0;

  L568:
  x4 = XEXP (x3, 2);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L569;
  goto ret0;

  L569:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L570;
  goto ret0;

  L570:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L571;
    }
  goto ret0;

  L571:
  x2 = XEXP (x1, 2);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[3] = x2;
      return 104;
    }
  goto ret0;

  L576:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ZERO_EXTRACT && 1)
    goto L577;
  goto ret0;

  L577:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && reg_or_0_operand (x4, DImode))
    {
      ro[2] = x4;
      goto L578;
    }
  goto ret0;

  L578:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 1 && 1)
    goto L579;
  goto ret0;

  L579:
  x4 = XEXP (x3, 2);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L580;
  goto ret0;

  L580:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L581;
  goto ret0;

  L581:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L582;
    }
  goto ret0;

  L582:
  x2 = XEXP (x1, 2);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[3] = x2;
      return 105;
    }
  goto ret0;

  L668:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L669;
    }
  goto ret0;

  L669:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 118;
  goto ret0;

  L681:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L682;
    }
  goto ret0;

  L682:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && XWINT (x2, 0) == 0 && 1)
    return 121;
  goto ret0;

  L536:
  x2 = XEXP (x1, 0);
  if (reg_or_0_operand (x2, DImode))
    {
      ro[2] = x2;
      goto L537;
    }
  goto ret0;

  L537:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, DImode))
    {
      ro[3] = x2;
      return 99;
    }
  goto ret0;
 ret0: return -1;
}

int
recog_2 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5;
  int tem;

  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != DFmode)
    goto ret0;
  switch (GET_CODE (x1))
    {
    case ABS:
      goto L395;
    case NEG:
      goto L403;
    case PLUS:
      goto L417;
    case FLOAT:
      goto L443;
    case FLOAT_EXTEND:
      goto L447;
    case DIV:
      goto L465;
    case MULT:
      goto L494;
    case MINUS:
      goto L517;
    case IF_THEN_ELSE:
      goto L774;
    case EQ:
    case LE:
    case LT:
    case LEU:
    case LTU:
      if (alpha_comparison_operator (x1, DFmode))
	{
	  ro[1] = x1;
	  goto L755;
	}
    }
  goto ret0;

  L395:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 72;
      }
  goto ret0;

  L403:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 74;
      }
  goto ret0;

  L417:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L418;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L413;
    }
  goto ret0;

  L418:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[1] = x3;
      goto L425;
    }
  goto ret0;

  L425:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L426;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 77;
      }
  goto ret0;

  L426:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[2] = x3;
      if (TARGET_FP)
	return 78;
      }
  goto ret0;

  L413:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 76;
      }
  goto ret0;

  L443:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 82;
      }
  goto ret0;

  L447:
  x2 = XEXP (x1, 0);
  if (nonimmediate_operand (x2, SFmode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 83;
      }
  goto ret0;

  L465:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L466;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L472;
    }
  goto ret0;

  L466:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[1] = x3;
      goto L479;
    }
  goto ret0;

  L479:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L480;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 87;
      }
  goto ret0;

  L480:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[2] = x3;
      if (TARGET_FP)
	return 89;
      }
  goto ret0;

  L472:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L473;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 86;
      }
  goto ret0;

  L473:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[2] = x3;
      if (TARGET_FP)
	return 88;
      }
  goto ret0;

  L494:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L495;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L490;
    }
  goto ret0;

  L495:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[1] = x3;
      goto L502;
    }
  goto ret0;

  L502:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L503;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 92;
      }
  goto ret0;

  L503:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[2] = x3;
      if (TARGET_FP)
	return 93;
      }
  goto ret0;

  L490:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 91;
      }
  goto ret0;

  L517:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L518;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L524;
    }
  goto ret0;

  L518:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[1] = x3;
      goto L531;
    }
  goto ret0;

  L531:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L532;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 96;
      }
  goto ret0;

  L532:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[2] = x3;
      if (TARGET_FP)
	return 98;
      }
  goto ret0;

  L524:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L525;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 95;
      }
  goto ret0;

  L525:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[2] = x3;
      if (TARGET_FP)
	return 97;
      }
  goto ret0;

  L774:
  x2 = XEXP (x1, 0);
  if (signed_comparison_operator (x2, VOIDmode))
    {
      ro[3] = x2;
      goto L800;
    }
  goto ret0;

  L800:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != DFmode)
    goto ret0;
  if (GET_CODE (x3) == FLOAT_EXTEND && 1)
    goto L801;
  if (reg_or_fp0_operand (x3, DFmode))
    {
      ro[4] = x3;
      goto L776;
    }
  L791:
  if (reg_or_fp0_operand (x3, DFmode))
    {
      ro[1] = x3;
      goto L792;
    }
  goto ret0;

  L801:
  x4 = XEXP (x3, 0);
  if (reg_or_fp0_operand (x4, SFmode))
    {
      ro[4] = x4;
      goto L802;
    }
  goto ret0;

  L802:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_DOUBLE && fp0_operand (x3, DFmode))
    {
      ro[2] = x3;
      goto L821;
    }
  goto ret0;

  L821:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L822;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L804;
    }
  goto ret0;

  L822:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[1] = x3;
      goto L823;
    }
  goto ret0;

  L823:
  x2 = XEXP (x1, 2);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[5] = x2;
      if (TARGET_FP)
	return 139;
      }
  goto ret0;

  L804:
  x2 = XEXP (x1, 2);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[5] = x2;
      if (TARGET_FP)
	return 137;
      }
  goto ret0;

  L776:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_DOUBLE && fp0_operand (x3, DFmode))
    {
      ro[2] = x3;
      goto L777;
    }
  x3 = XEXP (x2, 0);
  goto L791;

  L777:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      goto L778;
    }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L791;

  L778:
  x2 = XEXP (x1, 2);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[5] = x2;
      if (TARGET_FP)
	return 134;
      }
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L791;

  L792:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_DOUBLE && fp0_operand (x3, DFmode))
    {
      ro[2] = x3;
      goto L793;
    }
  goto ret0;

  L793:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DFmode && GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L794;
  goto ret0;

  L794:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[4] = x3;
      goto L795;
    }
  goto ret0;

  L795:
  x2 = XEXP (x1, 2);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[5] = x2;
      if (TARGET_FP)
	return 136;
      }
  goto ret0;

  L755:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L756;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[2] = x2;
      goto L762;
    }
  goto ret0;

  L756:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[2] = x3;
      goto L769;
    }
  goto ret0;

  L769:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L770;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[3] = x2;
      if (TARGET_FP)
	return 131;
      }
  goto ret0;

  L770:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[3] = x3;
      if (TARGET_FP)
	return 133;
      }
  goto ret0;

  L762:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DFmode)
    goto ret0;
  if (GET_CODE (x2) == FLOAT_EXTEND && 1)
    goto L763;
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[3] = x2;
      if (TARGET_FP)
	return 130;
      }
  goto ret0;

  L763:
  x3 = XEXP (x2, 0);
  if (reg_or_fp0_operand (x3, SFmode))
    {
      ro[3] = x3;
      if (TARGET_FP)
	return 132;
      }
  goto ret0;
 ret0: return -1;
}

int
recog_3 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5;
  int tem;

  x1 = XEXP (x0, 0);
  switch (GET_MODE (x1))
    {
    case DImode:
      if (register_operand (x1, DImode))
	{
	  ro[0] = x1;
	  goto L2;
	}
    L1013:
      if (general_operand (x1, DImode))
	{
	  ro[0] = x1;
	  goto L1014;
	}
      break;
    case SImode:
      if (GET_CODE (x1) == REG && XINT (x1, 0) == 27 && 1)
	goto L168;
    L5:
      if (register_operand (x1, SImode))
	{
	  ro[0] = x1;
	  goto L6;
	}
    L1001:
      if (nonimmediate_operand (x1, SImode))
	{
	  ro[0] = x1;
	  goto L1002;
	}
    }
  L182:
  switch (GET_MODE (x1))
    {
    case DImode:
      if (GET_CODE (x1) == REG && XINT (x1, 0) == 27 && 1)
	goto L183;
      break;
    case HImode:
      if (register_operand (x1, HImode))
	{
	  ro[0] = x1;
	  goto L198;
	}
    L1004:
      if (nonimmediate_operand (x1, HImode))
	{
	  ro[0] = x1;
	  goto L1005;
	}
      break;
    case SFmode:
      if (register_operand (x1, SFmode))
	{
	  ro[0] = x1;
	  goto L390;
	}
    L995:
      if (nonimmediate_operand (x1, SFmode))
	{
	  ro[0] = x1;
	  goto L996;
	}
      break;
    case DFmode:
      if (register_operand (x1, DFmode))
	{
	  ro[0] = x1;
	  goto L394;
	}
    L998:
      if (nonimmediate_operand (x1, DFmode))
	{
	  ro[0] = x1;
	  goto L999;
	}
      break;
    case QImode:
      if (nonimmediate_operand (x1, QImode))
	{
	  ro[0] = x1;
	  goto L1008;
	}
    }
  if (GET_CODE (x1) == PC && 1)
    goto L970;
  goto ret0;
 L2:
  tem = recog_1 (x0, insn, pnum_clobbers);
  if (tem >= 0) return tem;
  x1 = XEXP (x0, 0);
  goto L1013;

  L1014:
  x1 = XEXP (x0, 1);
  if (input_operand (x1, DImode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], DImode)
   || reg_or_0_operand (operands[1], DImode))
	return 196;
      }
  x1 = XEXP (x0, 0);
  goto L182;

  L168:
  x1 = XEXP (x0, 1);
  if (divmod_operator (x1, SImode))
    {
      ro[1] = x1;
      goto L169;
    }
  x1 = XEXP (x0, 0);
  goto L5;

  L169:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 24 && 1)
    goto L170;
  x1 = XEXP (x0, 0);
  goto L5;

  L170:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == REG && XINT (x2, 0) == 25 && pnum_clobbers != 0 && 1)
    {
      *pnum_clobbers = 2;
      return 33;
    }
  x1 = XEXP (x0, 0);
  goto L5;

  L6:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != SImode)
    {
      x1 = XEXP (x0, 0);
      goto L1001;
    }
  switch (GET_CODE (x1))
    {
    case PLUS:
      goto L42;
    case NEG:
      goto L92;
    case MINUS:
      goto L121;
    case MULT:
      goto L143;
    case ZERO_EXTEND:
      goto L203;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L42:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SImode:
      switch (GET_CODE (x2))
	{
	case MULT:
	  goto L43;
	case PLUS:
	  goto L65;
	}
    }
  if (reg_or_0_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L8;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L43:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L44;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L44:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && const48_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L45;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L45:
  x2 = XEXP (x1, 1);
  if (sext_add_operand (x2, SImode))
    {
      ro[3] = x2;
      return 7;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L65:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == MULT && 1)
    goto L66;
  x1 = XEXP (x0, 0);
  goto L1001;

  L66:
  x4 = XEXP (x3, 0);
  if (reg_or_0_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L67;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L67:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && const48_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L68;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L68:
  x3 = XEXP (x2, 1);
  if (register_operand (x3, SImode))
    {
      ro[3] = x3;
      goto L69;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L69:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[4] = x2;
      if (reload_in_progress)
	return 10;
      }
  x1 = XEXP (x0, 0);
  goto L1001;

  L8:
  x2 = XEXP (x1, 1);
  if (add_operand (x2, SImode))
    {
      ro[2] = x2;
      return 1;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L92:
  x2 = XEXP (x1, 0);
  if (reg_or_8bit_operand (x2, SImode))
    {
      ro[1] = x2;
      return 13;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L121:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == SImode && GET_CODE (x2) == MULT && 1)
    goto L122;
  if (reg_or_0_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L106;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L122:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, SImode))
    {
      ro[1] = x3;
      goto L123;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L123:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && const48_operand (x3, SImode))
    {
      ro[2] = x3;
      goto L124;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L124:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, SImode))
    {
      ro[3] = x2;
      return 19;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L106:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, SImode))
    {
      ro[2] = x2;
      return 16;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L143:
  x2 = XEXP (x1, 0);
  if (reg_or_0_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L144;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L144:
  x2 = XEXP (x1, 1);
  if (reg_or_8bit_operand (x2, SImode))
    {
      ro[2] = x2;
      return 22;
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L203:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case QImode:
      if (register_operand (x2, QImode))
	{
	  ro[1] = x2;
	  return 38;
	}
      break;
    case HImode:
      if (register_operand (x2, HImode))
	{
	  ro[1] = x2;
	  return 40;
	}
    }
  x1 = XEXP (x0, 0);
  goto L1001;

  L1002:
  x1 = XEXP (x0, 1);
  if (input_operand (x1, SImode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], SImode)
   || reg_or_0_operand (operands[1], SImode))
	return 191;
      }
  goto ret0;

  L183:
  x1 = XEXP (x0, 1);
  if (divmod_operator (x1, DImode))
    {
      ro[1] = x1;
      goto L184;
    }
  goto ret0;

  L184:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 24 && 1)
    goto L185;
  goto ret0;

  L185:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 25 && pnum_clobbers != 0 && 1)
    {
      *pnum_clobbers = 2;
      return 34;
    }
  goto ret0;

  L198:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) == HImode && GET_CODE (x1) == ZERO_EXTEND && 1)
    goto L199;
  x1 = XEXP (x0, 0);
  goto L1004;

  L199:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, QImode))
    {
      ro[1] = x2;
      return 37;
    }
  x1 = XEXP (x0, 0);
  goto L1004;

  L1005:
  x1 = XEXP (x0, 1);
  if (input_operand (x1, HImode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], HImode)
   || register_operand (operands[1], HImode))
	return 192;
      }
  goto ret0;

  L390:
  x1 = XEXP (x0, 1);
  if (GET_MODE (x1) != SFmode)
    {
      x1 = XEXP (x0, 0);
      goto L995;
    }
  switch (GET_CODE (x1))
    {
    case ABS:
      goto L391;
    case NEG:
      goto L399;
    case PLUS:
      goto L407;
    case FLOAT:
      goto L439;
    case FLOAT_TRUNCATE:
      goto L451;
    case DIV:
      goto L455;
    case MULT:
      goto L484;
    case MINUS:
      goto L507;
    case IF_THEN_ELSE:
      goto L782;
    }
  x1 = XEXP (x0, 0);
  goto L995;

  L391:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 71;
      }
  x1 = XEXP (x0, 0);
  goto L995;

  L399:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 73;
      }
  x1 = XEXP (x0, 0);
  goto L995;

  L407:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L408;
    }
  x1 = XEXP (x0, 0);
  goto L995;

  L408:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 75;
      }
  x1 = XEXP (x0, 0);
  goto L995;

  L439:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 81;
      }
  x1 = XEXP (x0, 0);
  goto L995;

  L451:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, DFmode))
    {
      ro[1] = x2;
      if (TARGET_FP)
	return 84;
      }
  x1 = XEXP (x0, 0);
  goto L995;

  L455:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L456;
    }
  x1 = XEXP (x0, 0);
  goto L995;

  L456:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 85;
      }
  x1 = XEXP (x0, 0);
  goto L995;

  L484:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L485;
    }
  x1 = XEXP (x0, 0);
  goto L995;

  L485:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 90;
      }
  x1 = XEXP (x0, 0);
  goto L995;

  L507:
  x2 = XEXP (x1, 0);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L508;
    }
  x1 = XEXP (x0, 0);
  goto L995;

  L508:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[2] = x2;
      if (TARGET_FP)
	return 94;
      }
  x1 = XEXP (x0, 0);
  goto L995;

  L782:
  x2 = XEXP (x1, 0);
  if (signed_comparison_operator (x2, VOIDmode))
    {
      ro[3] = x2;
      goto L809;
    }
  x1 = XEXP (x0, 0);
  goto L995;

  L809:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != DFmode)
    {
      x1 = XEXP (x0, 0);
      goto L995;
    }
  if (GET_CODE (x3) == FLOAT_EXTEND && 1)
    goto L810;
  if (reg_or_fp0_operand (x3, DFmode))
    {
      ro[4] = x3;
      goto L784;
    }
  x1 = XEXP (x0, 0);
  goto L995;

  L810:
  x4 = XEXP (x3, 0);
  if (reg_or_fp0_operand (x4, SFmode))
    {
      ro[4] = x4;
      goto L811;
    }
  x1 = XEXP (x0, 0);
  goto L995;

  L811:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_DOUBLE && fp0_operand (x3, DFmode))
    {
      ro[2] = x3;
      goto L812;
    }
  x1 = XEXP (x0, 0);
  goto L995;

  L812:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L813;
    }
  x1 = XEXP (x0, 0);
  goto L995;

  L813:
  x2 = XEXP (x1, 2);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[5] = x2;
      if (TARGET_FP)
	return 138;
      }
  x1 = XEXP (x0, 0);
  goto L995;

  L784:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_DOUBLE && fp0_operand (x3, DFmode))
    {
      ro[2] = x3;
      goto L785;
    }
  x1 = XEXP (x0, 0);
  goto L995;

  L785:
  x2 = XEXP (x1, 1);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[1] = x2;
      goto L786;
    }
  x1 = XEXP (x0, 0);
  goto L995;

  L786:
  x2 = XEXP (x1, 2);
  if (reg_or_fp0_operand (x2, SFmode))
    {
      ro[5] = x2;
      if (TARGET_FP)
	return 135;
      }
  x1 = XEXP (x0, 0);
  goto L995;

  L996:
  x1 = XEXP (x0, 1);
  if (input_operand (x1, SFmode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], SFmode)
   || reg_or_fp0_operand (operands[1], SFmode))
	return 187;
      }
  goto ret0;
 L394:
  tem = recog_2 (x0, insn, pnum_clobbers);
  if (tem >= 0) return tem;
  x1 = XEXP (x0, 0);
  goto L998;

  L999:
  x1 = XEXP (x0, 1);
  if (input_operand (x1, DFmode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], DFmode)
   || reg_or_fp0_operand (operands[1], DFmode))
	return 188;
      }
  goto ret0;

  L1008:
  x1 = XEXP (x0, 1);
  if (input_operand (x1, QImode))
    {
      ro[1] = x1;
      if (register_operand (operands[0], QImode)
   || register_operand (operands[1], QImode))
	return 193;
      }
  goto ret0;

  L970:
  x1 = XEXP (x0, 1);
  if (register_operand (x1, DImode))
    {
      ro[0] = x1;
      return 182;
    }
  switch (GET_CODE (x1))
    {
    case IF_THEN_ELSE:
      goto L702;
    case LABEL_REF:
      goto L966;
    }
  goto ret0;

  L702:
  x2 = XEXP (x1, 0);
  if (signed_comparison_operator (x2, VOIDmode))
    {
      ro[1] = x2;
      goto L837;
    }
  L711:
  switch (GET_CODE (x2))
    {
    case NE:
      goto L712;
    case EQ:
      goto L724;
    }
  goto ret0;

  L837:
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case DFmode:
      if (GET_CODE (x3) == FLOAT_EXTEND && 1)
	goto L838;
      if (reg_or_fp0_operand (x3, DFmode))
	{
	  ro[2] = x3;
	  goto L829;
	}
    }
  L703:
  if (reg_or_0_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L704;
    }
  goto L711;

  L838:
  x4 = XEXP (x3, 0);
  if (reg_or_fp0_operand (x4, SFmode))
    {
      ro[2] = x4;
      goto L839;
    }
  goto L711;

  L839:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_DOUBLE && fp0_operand (x3, DFmode))
    {
      ro[3] = x3;
      goto L840;
    }
  goto L711;

  L840:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L841;
  x2 = XEXP (x1, 0);
  goto L711;

  L841:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L842;

  L842:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    if (TARGET_FP)
      return 145;
  x2 = XEXP (x1, 0);
  goto L711;

  L829:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_DOUBLE && fp0_operand (x3, DFmode))
    {
      ro[3] = x3;
      goto L830;
    }
  x3 = XEXP (x2, 0);
  goto L703;

  L830:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L831;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L703;

  L831:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L832;

  L832:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    if (TARGET_FP)
      return 144;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  goto L703;

  L704:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L705;
  goto L711;

  L705:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L706;
  x2 = XEXP (x1, 0);
  goto L711;

  L706:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L707;

  L707:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 126;
  x2 = XEXP (x1, 0);
  goto L711;

  L712:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ZERO_EXTRACT && 1)
    goto L713;
  goto ret0;

  L713:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && reg_or_0_operand (x4, DImode))
    {
      ro[1] = x4;
      goto L714;
    }
  goto ret0;

  L714:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 1 && 1)
    goto L715;
  goto ret0;

  L715:
  x4 = XEXP (x3, 2);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L716;
  goto ret0;

  L716:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L717;
  goto ret0;

  L717:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L718;
  goto ret0;

  L718:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L719;

  L719:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 127;
  goto ret0;

  L724:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ZERO_EXTRACT && 1)
    goto L725;
  goto ret0;

  L725:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && reg_or_0_operand (x4, DImode))
    {
      ro[1] = x4;
      goto L726;
    }
  goto ret0;

  L726:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 1 && 1)
    goto L727;
  goto ret0;

  L727:
  x4 = XEXP (x3, 2);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L728;
  goto ret0;

  L728:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && XWINT (x3, 0) == 0 && 1)
    goto L729;
  goto ret0;

  L729:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L730;
  goto ret0;

  L730:
  x3 = XEXP (x2, 0);
  ro[0] = x3;
  goto L731;

  L731:
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) == PC && 1)
    return 128;
  goto ret0;

  L966:
  x2 = XEXP (x1, 0);
  ro[0] = x2;
  return 180;
 ret0: return -1;
}

int
recog_4 (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5;
  int tem;

  x1 = XVECEXP (x0, 0, 0);
  switch (GET_CODE (x1))
    {
    case SET:
      goto L158;
    case CALL:
      goto L891;
    }
  goto ret0;

  L158:
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case SImode:
      switch (GET_CODE (x2))
	{
	case REG:
	  if (XINT (x2, 0) == 27 && 1)
	    goto L159;
	}
      break;
    case DImode:
      switch (GET_CODE (x2))
	{
	case REG:
	  if (XINT (x2, 0) == 27 && 1)
	    goto L174;
	}
    }
  if (GET_CODE (x2) == PC && 1)
    goto L975;
  L907:
  if (register_operand (x2, VOIDmode))
    {
      ro[0] = x2;
      goto L908;
    }
  goto ret0;

  L159:
  x2 = XEXP (x1, 1);
  if (divmod_operator (x2, SImode))
    {
      ro[1] = x2;
      goto L160;
    }
  x2 = XEXP (x1, 0);
  goto L907;

  L160:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 24 && 1)
    goto L161;
  x2 = XEXP (x1, 0);
  goto L907;

  L161:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == REG && XINT (x3, 0) == 25 && 1)
    goto L162;
  x2 = XEXP (x1, 0);
  goto L907;

  L162:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L163;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L907;

  L163:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 23 && 1)
    goto L164;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L907;

  L164:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L165;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L907;

  L165:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 28 && 1)
    return 33;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L907;

  L174:
  x2 = XEXP (x1, 1);
  if (divmod_operator (x2, DImode))
    {
      ro[1] = x2;
      goto L175;
    }
  x2 = XEXP (x1, 0);
  goto L907;

  L175:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == REG && XINT (x3, 0) == 24 && 1)
    goto L176;
  x2 = XEXP (x1, 0);
  goto L907;

  L176:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == REG && XINT (x3, 0) == 25 && 1)
    goto L177;
  x2 = XEXP (x1, 0);
  goto L907;

  L177:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L178;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L907;

  L178:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 23 && 1)
    goto L179;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L907;

  L179:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L180;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L907;

  L180:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 28 && 1)
    return 34;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L907;

  L975:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == PLUS && 1)
    goto L976;
  goto ret0;

  L976:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DImode))
    {
      ro[0] = x3;
      goto L977;
    }
  goto ret0;

  L977:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == REG && XINT (x3, 0) == 29 && 1)
    goto L978;
  goto ret0;

  L978:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L979;
  goto ret0;

  L979:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L980;
  goto ret0;

  L980:
  x3 = XEXP (x2, 0);
  ro[1] = x3;
  goto L981;

  L981:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L982;
  goto ret0;

  L982:
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, DImode))
    {
      ro[2] = x2;
      return 185;
    }
  goto ret0;

  L908:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CALL && 1)
    goto L909;
  goto ret0;

  L909:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == MEM && 1)
    goto L910;
  goto ret0;

  L910:
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
      if (GET_MODE (x4) == DImode && XINT (x4, 0) == 27 && 1)
	goto L911;
      break;
    case SYMBOL_REF:
      if (GET_CODE (x4) == SYMBOL_REF && current_file_function_operand (x4, VOIDmode))
	{
	  ro[1] = x4;
	  goto L947;
	}
    }
  goto ret0;

  L911:
  x3 = XEXP (x2, 1);
  ro[1] = x3;
  goto L912;

  L912:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L913;
  goto ret0;

  L913:
  x2 = XEXP (x1, 0);
  ro[2] = x2;
  goto L914;

  L914:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L915;
  goto ret0;

  L915:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 26 && 1)
    return 175;
  goto ret0;

  L947:
  x3 = XEXP (x2, 1);
  ro[2] = x3;
  goto L948;

  L948:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L949;
  goto ret0;

  L949:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[1]) && 1)
    goto L950;
  goto ret0;

  L950:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L951;
  goto ret0;

  L951:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 26 && 1)
    return 177;
  goto ret0;

  L891:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == MEM && 1)
    goto L892;
  goto ret0;

  L892:
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
      if (GET_MODE (x3) == DImode && XINT (x3, 0) == 27 && 1)
	goto L893;
      break;
    case SYMBOL_REF:
      if (GET_CODE (x3) == SYMBOL_REF && current_file_function_operand (x3, VOIDmode))
	{
	  ro[1] = x3;
	  goto L929;
	}
    }
  goto ret0;

  L893:
  x2 = XEXP (x1, 1);
  ro[0] = x2;
  goto L894;

  L894:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L895;
  goto ret0;

  L895:
  x2 = XEXP (x1, 0);
  ro[1] = x2;
  goto L896;

  L896:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L897;
  goto ret0;

  L897:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 26 && 1)
    return 174;
  goto ret0;

  L929:
  x2 = XEXP (x1, 1);
  ro[0] = x2;
  goto L930;

  L930:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L931;
  goto ret0;

  L931:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[1]) && 1)
    goto L932;
  goto ret0;

  L932:
  x1 = XVECEXP (x0, 0, 2);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L933;
  goto ret0;

  L933:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == REG && XINT (x2, 0) == 26 && 1)
    return 176;
  goto ret0;
 ret0: return -1;
}

int
recog (x0, insn, pnum_clobbers)
     register rtx x0;
     rtx insn;
     int *pnum_clobbers;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5;
  int tem;

  L0:
  switch (GET_CODE (x0))
    {
    case SET:
      goto L1;
    case PARALLEL:
      if (XVECLEN (x0, 0) == 3 && 1)
	goto L157;
      if (XVECLEN (x0, 0) == 2 && 1)
	goto L584;
      break;
    case UNSPEC_VOLATILE:
      if (XINT (x0, 1) == 1 && XVECLEN (x0, 0) == 1 && 1)
	goto L962;
      if (XINT (x0, 1) == 0 && XVECLEN (x0, 0) == 1 && 1)
	goto L993;
      break;
    case RETURN:
      if (direct_return ())
	return 181;
      break;
    case CONST_INT:
      if (XWINT (x0, 0) == 0 && 1)
	return 183;
    }
  goto ret0;
 L1:
  return recog_3 (x0, insn, pnum_clobbers);
 L157:
  return recog_4 (x0, insn, pnum_clobbers);

  L584:
  x1 = XVECEXP (x0, 0, 0);
  switch (GET_CODE (x1))
    {
    case SET:
      goto L585;
    case CALL:
      goto L900;
    }
  goto ret0;

  L585:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[0] = x2;
      goto L586;
    }
  if (GET_CODE (x2) == PC && 1)
    goto L986;
  L918:
  if (register_operand (x2, VOIDmode))
    {
      ro[0] = x2;
      goto L919;
    }
  goto ret0;

  L586:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == IF_THEN_ELSE && 1)
    goto L587;
  x2 = XEXP (x1, 0);
  goto L918;

  L587:
  x3 = XEXP (x2, 0);
  if (signed_comparison_operator (x3, VOIDmode))
    {
      ro[2] = x3;
      goto L588;
    }
  x2 = XEXP (x1, 0);
  goto L918;

  L588:
  x4 = XEXP (x3, 0);
  if (reg_or_0_operand (x4, DImode))
    {
      ro[3] = x4;
      goto L589;
    }
  x2 = XEXP (x1, 0);
  goto L918;

  L589:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L590;
  x2 = XEXP (x1, 0);
  goto L918;

  L590:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == PLUS && 1)
    goto L591;
  x2 = XEXP (x1, 0);
  goto L918;

  L591:
  x4 = XEXP (x3, 0);
  if (rtx_equal_p (x4, ro[0]) && 1)
    goto L592;
  x2 = XEXP (x1, 0);
  goto L918;

  L592:
  x4 = XEXP (x3, 1);
  if (reg_or_8bit_operand (x4, DImode))
    {
      ro[1] = x4;
      goto L593;
    }
  x2 = XEXP (x1, 0);
  goto L918;

  L593:
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, ro[0]) && 1)
    goto L594;
  x2 = XEXP (x1, 0);
  goto L918;

  L594:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L595;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L918;

  L595:
  x2 = XEXP (x1, 0);
  if (scratch_operand (x2, DImode))
    {
      ro[4] = x2;
      return 106;
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 0);
  goto L918;

  L986:
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == PLUS && 1)
    goto L987;
  goto ret0;

  L987:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DImode))
    {
      ro[0] = x3;
      goto L988;
    }
  goto ret0;

  L988:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == REG && XINT (x3, 0) == 29 && 1)
    goto L989;
  goto ret0;

  L989:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L990;
  goto ret0;

  L990:
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == LABEL_REF && 1)
    goto L991;
  goto ret0;

  L991:
  x3 = XEXP (x2, 0);
  if (pnum_clobbers != 0 && 1)
    {
      ro[1] = x3;
      *pnum_clobbers = 1;
      return 185;
    }
  goto ret0;

  L919:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CALL && 1)
    goto L920;
  goto ret0;

  L920:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == MEM && 1)
    goto L921;
  goto ret0;

  L921:
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
      if (GET_MODE (x4) == DImode && XINT (x4, 0) == 27 && 1)
	goto L922;
      break;
    case SYMBOL_REF:
      if (GET_CODE (x4) == SYMBOL_REF && current_file_function_operand (x4, VOIDmode))
	{
	  ro[1] = x4;
	  goto L958;
	}
    }
  goto ret0;

  L922:
  x3 = XEXP (x2, 1);
  ro[1] = x3;
  goto L923;

  L923:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L924;
  goto ret0;

  L924:
  x2 = XEXP (x1, 0);
  if (pnum_clobbers != 0 && 1)
    {
      ro[2] = x2;
      *pnum_clobbers = 1;
      return 175;
    }
  goto ret0;

  L958:
  x3 = XEXP (x2, 1);
  ro[2] = x3;
  goto L959;

  L959:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L960;
  goto ret0;

  L960:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[1]) && pnum_clobbers != 0 && 1)
    {
      *pnum_clobbers = 1;
      return 177;
    }
  goto ret0;

  L900:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == MEM && 1)
    goto L901;
  goto ret0;

  L901:
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
      if (GET_MODE (x3) == DImode && XINT (x3, 0) == 27 && 1)
	goto L902;
      break;
    case SYMBOL_REF:
      if (GET_CODE (x3) == SYMBOL_REF && current_file_function_operand (x3, VOIDmode))
	{
	  ro[1] = x3;
	  goto L938;
	}
    }
  goto ret0;

  L902:
  x2 = XEXP (x1, 1);
  ro[0] = x2;
  goto L903;

  L903:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L904;
  goto ret0;

  L904:
  x2 = XEXP (x1, 0);
  if (pnum_clobbers != 0 && 1)
    {
      ro[1] = x2;
      *pnum_clobbers = 1;
      return 174;
    }
  goto ret0;

  L938:
  x2 = XEXP (x1, 1);
  ro[0] = x2;
  goto L939;

  L939:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == USE && 1)
    goto L940;
  goto ret0;

  L940:
  x2 = XEXP (x1, 0);
  if (rtx_equal_p (x2, ro[1]) && pnum_clobbers != 0 && 1)
    {
      *pnum_clobbers = 1;
      return 176;
    }
  goto ret0;

  L962:
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == CONST_INT && XWINT (x1, 0) == 0 && 1)
    return 179;
  goto ret0;

  L993:
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == CONST_INT && XWINT (x1, 0) == 0 && 1)
    return 186;
  goto ret0;
 ret0: return -1;
}

rtx
split_1 (x0, insn)
     register rtx x0;
     rtx insn;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5;
  rtx tem;

  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != DImode)
    goto ret0;
  switch (GET_CODE (x2))
    {
    case SIGN_EXTEND:
      goto L24;
    case ASHIFT:
      goto L328;
    case IF_THEN_ELSE:
      goto L610;
    case ABS:
      goto L637;
    case NEG:
      goto L648;
    case SMAX:
      goto L661;
    case SMIN:
      goto L674;
    case UMAX:
      goto L687;
    case UMIN:
      goto L695;
    }
  goto ret0;

  L24:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == SImode && GET_CODE (x3) == PLUS && 1)
    goto L25;
  goto ret0;

  L25:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, SImode))
    {
      ro[1] = x4;
      goto L26;
    }
  goto ret0;

  L26:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && 1)
    {
      ro[2] = x4;
      goto L27;
    }
  goto ret0;

  L27:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L28;
  goto ret0;

  L28:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[3] = x2;
      if (! sext_add_operand (operands[2], SImode) && INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) % 4 == 0)
	return gen_split_4 (operands);
      }
  goto ret0;

  L328:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ZERO_EXTRACT && 1)
    goto L329;
  goto ret0;

  L329:
  x4 = XEXP (x3, 0);
  if (register_operand (x4, DImode))
    {
      ro[1] = x4;
      goto L330;
    }
  goto ret0;

  L330:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && mode_width_operand (x4, DImode))
    {
      ro[2] = x4;
      goto L331;
    }
  goto ret0;

  L331:
  x4 = XEXP (x3, 2);
  if (GET_MODE (x4) == DImode && GET_CODE (x4) == ASHIFT && 1)
    goto L332;
  goto ret0;

  L332:
  x5 = XEXP (x4, 0);
  ro[3] = x5;
  goto L333;

  L333:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == 3 && 1)
    goto L334;
  goto ret0;

  L334:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT && 1)
    {
      ro[4] = x3;
      goto L335;
    }
  goto ret0;

  L335:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L336;
  goto ret0;

  L336:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[5] = x2;
      if (INTVAL (operands[4]) == 64 - INTVAL (operands[2]))
	return gen_split_63 (operands);
      }
  goto ret0;

  L610:
  x3 = XEXP (x2, 0);
  if (signed_comparison_operator (x3, VOIDmode))
    {
      ro[2] = x3;
      goto L611;
    }
  L623:
  if (comparison_operator (x3, VOIDmode))
    {
      ro[1] = x3;
      goto L624;
    }
  goto ret0;

  L611:
  x4 = XEXP (x3, 0);
  if (reg_or_0_operand (x4, DImode))
    {
      ro[3] = x4;
      goto L612;
    }
  goto L623;

  L612:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L613;
  goto L623;

  L613:
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == PLUS && 1)
    goto L614;
  x3 = XEXP (x2, 0);
  goto L623;

  L614:
  x4 = XEXP (x3, 0);
  if (rtx_equal_p (x4, ro[0]) && 1)
    goto L615;
  x3 = XEXP (x2, 0);
  goto L623;

  L615:
  x4 = XEXP (x3, 1);
  if (reg_or_8bit_operand (x4, DImode))
    {
      ro[1] = x4;
      goto L616;
    }
  x3 = XEXP (x2, 0);
  goto L623;

  L616:
  x3 = XEXP (x2, 2);
  if (rtx_equal_p (x3, ro[0]) && 1)
    goto L617;
  x3 = XEXP (x2, 0);
  goto L623;

  L617:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L618;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L623;

  L618:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[4] = x2;
      return gen_split_107 (operands);
    }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  goto L623;

  L624:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && GET_CODE (x4) == ZERO_EXTRACT && 1)
    goto L625;
  if (reg_or_0_operand (x4, DImode))
    {
      ro[2] = x4;
      goto L849;
    }
  L859:
  if (reg_or_0_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L860;
    }
  goto ret0;

  L625:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, DImode))
    {
      ro[2] = x5;
      goto L626;
    }
  goto ret0;

  L626:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == 1 && 1)
    goto L627;
  goto ret0;

  L627:
  x5 = XEXP (x4, 2);
  if (GET_CODE (x5) == CONST_INT && 1)
    {
      ro[3] = x5;
      goto L628;
    }
  goto ret0;

  L628:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L629;
  goto ret0;

  L629:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[4] = x3;
      goto L630;
    }
  goto ret0;

  L630:
  x3 = XEXP (x2, 2);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[5] = x3;
      goto L631;
    }
  goto ret0;

  L631:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L632;
  goto ret0;

  L632:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[6] = x2;
      if (INTVAL (operands[3]) != 0)
	return gen_split_108 (operands);
      }
  goto ret0;

  L849:
  x4 = XEXP (x3, 1);
  if (reg_or_cint_operand (x4, DImode))
    {
      ro[3] = x4;
      goto L850;
    }
  x4 = XEXP (x3, 0);
  goto L859;

  L850:
  x3 = XEXP (x2, 1);
  if (reg_or_cint_operand (x3, DImode))
    {
      ro[4] = x3;
      goto L851;
    }
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L859;

  L851:
  x3 = XEXP (x2, 2);
  if (reg_or_cint_operand (x3, DImode))
    {
      ro[5] = x3;
      goto L852;
    }
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L859;

  L852:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L853;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L859;

  L853:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[6] = x2;
      if (operands[3] != const0_rtx)
	return gen_split_168 (operands);
      }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L859;

  L860:
  x4 = XEXP (x3, 1);
  if (reg_or_cint_operand (x4, SImode))
    {
      ro[3] = x4;
      goto L861;
    }
  goto ret0;

  L861:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[4] = x3;
      goto L862;
    }
  goto ret0;

  L862:
  x3 = XEXP (x2, 2);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[5] = x3;
      goto L863;
    }
  goto ret0;

  L863:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L864;
  goto ret0;

  L864:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[6] = x2;
      if (operands[3] != const0_rtx
   && (GET_CODE (operands[1]) == EQ || GET_CODE (operands[1]) == NE))
	return gen_split_169 (operands);
      }
  goto ret0;

  L637:
  x3 = XEXP (x2, 0);
  if (rtx_equal_p (x3, ro[0]) && 1)
    goto L638;
  goto ret0;

  L638:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L639;
  goto ret0;

  L639:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[2] = x2;
      return gen_split_112 (operands);
    }
  goto ret0;

  L648:
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) == DImode && GET_CODE (x3) == ABS && 1)
    goto L649;
  goto ret0;

  L649:
  x4 = XEXP (x3, 0);
  if (rtx_equal_p (x4, ro[0]) && 1)
    goto L650;
  goto ret0;

  L650:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L651;
  goto ret0;

  L651:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[2] = x2;
      return gen_split_114 (operands);
    }
  goto ret0;

  L661:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L662;
    }
  goto ret0;

  L662:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L663;
    }
  goto ret0;

  L663:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L664;
  goto ret0;

  L664:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[3] = x2;
      if (operands[2] != const0_rtx)
	return gen_split_117 (operands);
      }
  goto ret0;

  L674:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L675;
    }
  goto ret0;

  L675:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L676;
    }
  goto ret0;

  L676:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L677;
  goto ret0;

  L677:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[3] = x2;
      if (operands[2] != const0_rtx)
	return gen_split_120 (operands);
      }
  goto ret0;

  L687:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L688;
    }
  goto ret0;

  L688:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L689;
    }
  goto ret0;

  L689:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L690;
  goto ret0;

  L690:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[3] = x2;
      if (operands[2] != const0_rtx)
	return gen_split_123 (operands);
      }
  goto ret0;

  L695:
  x3 = XEXP (x2, 0);
  if (reg_or_0_operand (x3, DImode))
    {
      ro[1] = x3;
      goto L696;
    }
  goto ret0;

  L696:
  x3 = XEXP (x2, 1);
  if (reg_or_8bit_operand (x3, DImode))
    {
      ro[2] = x3;
      goto L697;
    }
  goto ret0;

  L697:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L698;
  goto ret0;

  L698:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[3] = x2;
      if (operands[2] != const0_rtx)
	return gen_split_125 (operands);
      }
  goto ret0;
 ret0: return 0;
}

rtx
split_insns (x0, insn)
     register rtx x0;
     rtx insn;
{
  register rtx *ro = &recog_operand[0];
  register rtx x1, x2, x3, x4, x5;
  rtx tem;

  L9:
  switch (GET_CODE (x0))
    {
    case SET:
      goto L10;
    case PARALLEL:
      if (XVECLEN (x0, 0) == 2 && 1)
	goto L21;
    }
  goto ret0;

  L10:
  x1 = XEXP (x0, 0);
  switch (GET_MODE (x1))
    {
    case SImode:
      if (register_operand (x1, SImode))
	{
	  ro[0] = x1;
	  goto L11;
	}
      break;
    case DImode:
      if (register_operand (x1, DImode))
	{
	  ro[0] = x1;
	  goto L36;
	}
    }
  goto ret0;

  L11:
  x1 = XEXP (x0, 1);
  switch (GET_CODE (x1))
    {
    case PLUS:
      if (GET_MODE (x1) == SImode && 1)
	goto L12;
      break;
    case CONST_INT:
      ro[1] = x1;
      if (! add_operand (operands[1], SImode))
	return gen_split_195 (operands);
    }
  goto ret0;

  L12:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, SImode))
    {
      ro[1] = x2;
      goto L13;
    }
  goto ret0;

  L13:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[2] = x2;
      if (! add_operand (operands[2], SImode))
	return gen_split_2 (operands);
      }
  goto ret0;

  L36:
  x1 = XEXP (x0, 1);
  switch (GET_MODE (x1))
    {
    case DImode:
      switch (GET_CODE (x1))
	{
	case PLUS:
	  goto L37;
	case AND:
	  goto L194;
	case ABS:
	  goto L643;
	case NEG:
	  goto L655;
	}
    }
  if (GET_CODE (x1) == CONST_INT && 1)
    {
      ro[1] = x1;
      if (! add_operand (operands[1], DImode))
	return gen_split_198 (operands);
      }
  goto ret0;

  L37:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L38;
    }
  goto ret0;

  L38:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[2] = x2;
      if (! add_operand (operands[2], DImode)
   && REGNO (operands[0]) != STACK_POINTER_REGNUM)
	return gen_split_6 (operands);
      }
  goto ret0;

  L194:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      goto L195;
    }
  goto ret0;

  L195:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == CONST_INT && 1)
    {
      ro[2] = x2;
      if (HOST_BITS_PER_WIDE_INT == 64 && ! and_operand (operands[2], DImode))
	return gen_split_36 (operands);
      }
  goto ret0;

  L643:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[1] = x2;
      if (! rtx_equal_p (operands[0], operands[1]))
	return gen_split_113 (operands);
      }
  goto ret0;

  L655:
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) == DImode && GET_CODE (x2) == ABS && 1)
    goto L656;
  goto ret0;

  L656:
  x3 = XEXP (x2, 0);
  if (register_operand (x3, DImode))
    {
      ro[1] = x3;
      if (! rtx_equal_p (operands[0], operands[1]))
	return gen_split_115 (operands);
      }
  goto ret0;

  L21:
  x1 = XVECEXP (x0, 0, 0);
  if (GET_CODE (x1) == SET && 1)
    goto L22;
  goto ret0;

  L22:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[0] = x2;
      goto L23;
    }
  if (GET_CODE (x2) == PC && 1)
    goto L735;
  goto ret0;
 L23:
  return split_1 (x0, insn);

  L735:
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) == IF_THEN_ELSE && 1)
    goto L736;
  goto ret0;

  L736:
  x3 = XEXP (x2, 0);
  if (comparison_operator (x3, VOIDmode))
    {
      ro[1] = x3;
      goto L737;
    }
  goto ret0;

  L737:
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == DImode && GET_CODE (x4) == ZERO_EXTRACT && 1)
    goto L738;
  if (reg_or_0_operand (x4, DImode))
    {
      ro[2] = x4;
      goto L871;
    }
  L882:
  if (reg_or_0_operand (x4, SImode))
    {
      ro[2] = x4;
      goto L883;
    }
  goto ret0;

  L738:
  x5 = XEXP (x4, 0);
  if (register_operand (x5, DImode))
    {
      ro[2] = x5;
      goto L739;
    }
  goto ret0;

  L739:
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) == CONST_INT && XWINT (x5, 0) == 1 && 1)
    goto L740;
  goto ret0;

  L740:
  x5 = XEXP (x4, 2);
  if (GET_CODE (x5) == CONST_INT && 1)
    {
      ro[3] = x5;
      goto L741;
    }
  goto ret0;

  L741:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && XWINT (x4, 0) == 0 && 1)
    goto L742;
  goto ret0;

  L742:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L743;
  goto ret0;

  L743:
  x4 = XEXP (x3, 0);
  ro[0] = x4;
  goto L744;

  L744:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L745;
  goto ret0;

  L745:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L746;
  goto ret0;

  L746:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[4] = x2;
      if (INTVAL (operands[3]) != 0)
	return gen_split_129 (operands);
      }
  goto ret0;

  L871:
  x4 = XEXP (x3, 1);
  if (reg_or_cint_operand (x4, DImode))
    {
      ro[3] = x4;
      goto L872;
    }
  x4 = XEXP (x3, 0);
  goto L882;

  L872:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L873;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L882;

  L873:
  x4 = XEXP (x3, 0);
  ro[0] = x4;
  goto L874;

  L874:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L875;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L882;

  L875:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L876;
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L882;

  L876:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[4] = x2;
      if (operands[3] != const0_rtx)
	return gen_split_170 (operands);
      }
  x1 = XVECEXP (x0, 0, 0);
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  goto L882;

  L883:
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT && 1)
    {
      ro[3] = x4;
      goto L884;
    }
  goto ret0;

  L884:
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == LABEL_REF && 1)
    goto L885;
  goto ret0;

  L885:
  x4 = XEXP (x3, 0);
  ro[0] = x4;
  goto L886;

  L886:
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) == PC && 1)
    goto L887;
  goto ret0;

  L887:
  x1 = XVECEXP (x0, 0, 1);
  if (GET_CODE (x1) == CLOBBER && 1)
    goto L888;
  goto ret0;

  L888:
  x2 = XEXP (x1, 0);
  if (register_operand (x2, DImode))
    {
      ro[4] = x2;
      if (operands[3] != const0_rtx
   && (GET_CODE (operands[1]) == EQ || GET_CODE (operands[1]) == NE))
	return gen_split_171 (operands);
      }
  goto ret0;
 ret0: return 0;
}

